// To prevent an infinite recurtion, we don't use memory macro in this file

namespace o {
namespace core {

	template <typename T> 
	static void DeleteInstance()
	{
		CAutoSingleton<T>::Destroy();
	}

	template <typename T> 
	T* CAutoSingleton<T>::singleton = null;

	template <typename T> 
	T* CAutoSingleton<T>::GetInstance()
	{
		if(singleton == null)
		{
			singleton = new T;
			atexit(DeleteInstance<T>);
		}
		return singleton;
	}

	template <typename T> 
	void CAutoSingleton<T>::Destroy()
	{
		if(singleton != null)
		{
			delete singleton;
			singleton = null;
		}
	}

	template <typename T> 
	bool CAutoSingleton<T>::IsCreated()
	{
		return singleton != null;
	}

}//namespace core
}//namespace o
