<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="log">
	<html>
		<head>
			<title>Log</title>
			<meta http-equiv="Content-Language" content="fr, be, ca, lu, ch" />
			<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=iso-8859-1" />
			<meta name="right" content="Copyright (c) 2002-2006 G-Truc Creation" />
			<link href="./css/main.css" rel="stylesheet" media="screen" type="text/css" />
			<link href="./css/news.css" rel="stylesheet" media="screen" type="text/css" />
			<!-- media="print" -->
		</head>
		<body>
			<!-- Title -->
			<div class="page-top" id="up">
				<div class="page-top-up"><xsl:text disable-output-escaping="yes"> </xsl:text></div>
				<div class="page-top-center"><xsl:text disable-output-escaping="yes"> </xsl:text></div>
				<div class="page-top-down"><xsl:text disable-output-escaping="yes"> </xsl:text></div>
			</div>

			<!-- Content -->
			<div class="page-content">
				<div>
          Filter : <a href="./index.html">Full</a> - <a href="./memory.html">Memory</a> - <a href="./test.html">Tests</a> - <a href="./warning.html">Warnings</a> - <a href="./error.html">Error</a> - <a href="./message.html">Messages</a>
          <div class="news-title">Full Log</div>
        </div>
      </div>
      <div class="page-content">
				<xsl:apply-templates />
			</div>

    </body>
	</html>
</xsl:template>

<xsl:template match="message">
  <div>
    <div class="news-title">Message : <xsl:value-of select="./@message" /></div>
    <div class="news-text">File : <xsl:value-of select="./@filename" /></div>
    <div class="news-text">Line : <xsl:value-of select="./@line" /></div>
  </div>
</xsl:template>

<xsl:template match="memory">
  <div>
    <div class="news-title">
      Memory : <xsl:value-of select="./@operator" />
    </div>
    <div class="news-text">
      Type : <xsl:value-of select="./@type" /> (<xsl:value-of select="./@size" /> bytes)
    </div>
    <div class="news-text">
      File : <xsl:value-of select="./@filename" />
    </div>
    <div class="news-text">
      Line : <xsl:value-of select="./@line" />
    </div>
  </div>
</xsl:template>

<xsl:template match="test">
  <div>
    <div class="news-title">
      Test : <xsl:value-of select="./@message" />
    </div>
    <div class="news-text">
      <xsl:value-of select="./@expression" /> is <xsl:value-of select="./@result" />
    </div>
    <div class="news-text">
      File : <xsl:value-of select="./@filename" />
    </div>
    <div class="news-text">
      Line : <xsl:value-of select="./@line" />
    </div>
  </div>
</xsl:template>

<xsl:template match="caution">
  <div>
    <div class="news-title">
      Warning : <xsl:value-of select="./@message" />
    </div>
    <div class="news-text">
      Test : <xsl:value-of select="./@expression" />
    </div>
    <div class="news-text">
      File : <xsl:value-of select="./@filename" />
    </div>
    <div class="news-text">
      Line : <xsl:value-of select="./@line" />
    </div>
  </div>
</xsl:template>

<xsl:template match="error">
  <div>
    <div class="news-title">
      Error : <xsl:value-of select="./@message" />
    </div>
    <div class="news-text">
      Test : <xsl:value-of select="./@expression" />
    </div>
    <div class="news-text">
      File : <xsl:value-of select="./@filename" />
    </div>
    <div class="news-text">
      Line : <xsl:value-of select="./@line" />
    </div>
  </div>
</xsl:template>

<xsl:template match="text">
	<div class="news-text">
		<xsl:apply-templates select="./paragraph" />
	</div>
</xsl:template>

<xsl:template match="paragraph">
	<p><xsl:apply-templates /></p>
</xsl:template>

<xsl:template match="source-element">
	<div class="news-text"><xsl:value-of select="./@type"/>: <a href="{./@address}"><xsl:value-of select="./@title"/></a></div>
</xsl:template>

<xsl:template match="image-list">
	<div class="news-image">
		<xsl:apply-templates select="./image-element" />
	</div>
</xsl:template>

<xsl:template match="image-element">
	<a href="{./@normal}"><img src="{./@small}" alt="{./@title}" /></a>
</xsl:template>

<xsl:template match="list">
	<xsl:value-of select="./@title" /> : <br />
	<xsl:apply-templates select="./element"/>
</xsl:template>

<xsl:template match="element">
	- <xsl:apply-templates /><br />
</xsl:template>

</xsl:stylesheet>
